admin/models.py
#!/usr/bin/env python3
# -*- coding: UTF-8 -*-

from app import BaseModel
import peewee as pw
from datetime import datetime
from user.models import User


from enum import Enum,unique
#添加 unique 装饰器
@unique
class Feedback_state(Enum):
    #0为未读，1为已读 -1为已回复
    Unread=0
    Read=1
    Replied=-1
@unique
class Feedback_kind(Enum):
    #0-举报用户 1-举报商品或悬赏 2-网站bug 3-个人疑问 4-交易维权 5-其他
    User=0
    Item=1
    Bug=2
    Question=3
    Transaction=4
    Other=5


class Feedback(BaseModel):
    """
    反馈信息
    继承自BaseModel，直接关联db，并且也继承了Model Model有提供增删查改的函数
    """
    #id = pw.IntegerField(primary_key=True)  # 主键，不显式定义的话peewee默认定义一个自增的id
    user_id = pw.ForeignKeyField(User, verbose_name="发布者的学号")
    publish_time = pw.DateTimeField(verbose_name="发布时间",
                                null=False,
                                default=datetime.now())

    #0-举报用户或交易 1-交易出现问题 2-网站bug问题，3-个人疑问 4-个人信息有问题等
    kind=pw.IntegerField(verbose_name="反馈种类",null=False,default=Feedback_kind.User.value,constraints=[pw.Check("kind >=0")])

    #0为未读，1为已读 -1为已回复
    state = pw.IntegerField(verbose_name="状态", null=False, default=Feedback_state.Unread.value,
                                constraints=[pw.Check("state >=-1")])
    feedback_content = pw.CharField(verbose_name="详细反馈", max_length=1024)
    reply_content=pw.CharField(verbose_name="管理员回复内容", max_length=1024)

class User_Management(BaseModel):
    """
    用户管理
    继承自BaseModel，直接关联db，并且也继承了Model Model有提供增删查改的函数
    """
    #id = pw.IntegerField(primary_key=True)  # 主键，不显式定义的话peewee默认定义一个自增的id
    user_id = pw.ForeignKeyField(User, verbose_name="发布者的学号")
    ban_time=pw.DateTimeField(verbose_name="解封时间",
                                null=False,
                                default=datetime.now())#置当用户表中state=-1时，可以改变此项的值以实现封号时间
    ban_reason=pw.CharField(verbose_name="封号原因", max_length=1024)

admin/__init__.py
#!/usr/bin/env python3
# -*- coding: UTF-8 -*-

###管理员
from flask import Blueprint

admin_blue = Blueprint('admin', __name__,static_folder="static",template_folder="templates")
from . import models
from . import routes

admin/routes.py
#!/usr/bin/env python3
# -*- coding: UTF-8 -*-
from admin import admin_blue
from admin.models import Feedback, Feedback_state
from app import database
from flask import render_template, flash, redirect, url_for
from flask_login import current_user
from user.models import User_state
from functools import wraps


@admin_blue.before_request
def before_request():
    if database.is_closed():
        database.connect()


@admin_blue.teardown_request
def teardown_request(exc):  # exc必须写上
    if not database.is_closed():
        database.close()


class AdminController:
    @staticmethod
    def requires_auth(show_err=0):
        def auth_func(f):
            def authenticate():
                if show_err == 0:
                    return redirect(url_for('login'))
                elif show_err == 401:
                    return render_template('404.html', error_code=401, message="请先登录")
                elif show_err == 404:
                    return render_template("404.html", error_code=404, message="此反馈不存在")
                else:
                    raise Exception("unexpected requires_auth param")

            @wraps(f)
            def decorated(*args, **kwargs):
                from flask_login import current_user
                from user.models import User_state
                if current_user.is_authenticated and current_user.state == User_state.Admin.value:
                    return f(*args, **kwargs)
                else:
                    return authenticate()

            return decorated

        return auth_func

    @staticmethod
    @admin_blue.route('/user_check', methods=['GET', 'POST'])
    @requires_auth(show_err=401)
    def user_check():
        # if current_user.is_authenticated and current_user.state == User_state.Admin.value:
        return render_template('user_check.html')
        # else:
        #     return render_template('404.html', error_code=401, message="您无权访问此页面")

    @staticmethod
    @admin_blue.route('/order_check', methods=['GET', 'POST'])
    @requires_auth(show_err=401)
    def order_check():
        # if current_user.is_authenticated and current_user.state == User_state.Admin.value:
        return render_template('order_check.html')
        # else:
        #     return render_template('404.html', error_code=401, message="您无权访问此页面")

    @staticmethod
    @admin_blue.route('/feedback_show', methods=['GET', 'POST'])
    @requires_auth(show_err=401)
    def feedback_show():
        # if current_user.is_authenticated and current_user.state == User_state.Admin.value:
        return render_template('feedback_show.html')
        # else:
        #     return render_template('404.html', error_code=401, message="您无权访问此页面")

    @staticmethod
    @admin_blue.route("/feedback/<int:feedback_id>/", methods=["GET", "POST"])
    @requires_auth(show_err=401)
    def feedback(feedback_id: int):
        # if current_user.is_authenticated and current_user.state == User_state.Admin.value:
        try:
            feedback = Feedback.get(Feedback.id == feedback_id)
        except Exception as e:
            return render_template("404.html",
                                   error_code=404,
                                   message="此反馈不存在")
        else:
            if feedback.state == Feedback_state.Unread.value:
                feedback.state = Feedback_state.Read.value
                feedback.save()
            return render_template("feedback_content.html",
                                   feedback_id=feedback_id)
        # else:
        #     return render_template('404.html', error_code=401, message="您无权访问此页面")

admin/templates/feedback_content.html
{% extends "base.html" %} {% block title %}
<title>反馈详情</title>
{% endblock %} {% block css %} {{ super() }} {% endblock %} {% block header %} {{ super() }} {% endblock %} {% block main %}
<main>
    <section class="shop--area shop-right-sidebar pt-90 pb-90">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-xl-3 col-lg-3 col-md-3 col-sm-12">{% include "cont_side.html" %}</div>
                <div class="col-xl-9 col-lg-9 col-md-9 col-sm-12">
                    <div id="testt"></div>

                    <div class="shop-cart-total">
                        <h3 class="title">反馈详情</h3>
                        <div class="shop-cart-widget">
                            <form action="javascript:void(0)">
                                <ul id="wrapper">
                                    <li class="shop-check-wrap" id="feedback_user_id">
                                        <span>反馈用户ID</span>
                                    </li>

                                    <li class="shop-check-wrap" id="feedback_type">
                                        <span>反馈类型</span>
                                    </li>
                                    <li class="shop-check-wrap" id="feedback_time">
                                        <span>反馈时间</span>
                                    </li>

                                    <li class="shop-check-wrap" id="feedback_status">
                                        <span>反馈状态</span>
                                    </li>

                                    <li class="shop-check-wrap" id="feedback_content">
                                        <span>反馈内容</span>
                                    </li>

                                    <li class="shop-check-wrap" id="feedback_reply_old">
                                        <span>当前回复</span>
                                    </li>

                                    <li class="shop-check-wrap">
                                        <span id="feedback_reply_new"></span>
                                        <textarea placeholder="请输入你的回复..."style="resize: none;" cols="50" rows="3" id="feedback_reply_text" /></textarea>
                                    </li>
                                </ul>
                                <div class="row justify-content-center" id="buttongroup">
                                    <button class="btn col-xl-3 col-lg-4" onclick="feedback_reply_submit()">提交回复</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</main>
{% endblock %} {% block footer %} {{ super() }} {% endblock %} {% block js %} {{ super() }}

<script type="text/javascript" charset="utf-8">
    var feedback_id = "{{ feedback_id|safe }}"; // 如果有python传过来的
    var debug = 0;

    function feedback_reply_submit() {
        let reply_url = "/api/reply_feedback";
        if (debug) reply_url = `http://127.0.0.1:4523/mock/927026${reply_url}`;
        $.ajax({
            url: reply_url,
            type: "put",
            data: JSON.stringify({ feedback_id: feedback_id, reply_content: $(feedback_reply_text).val() }),
            contentType: "application/json;charset=utf-8",
            processData: false,
            success: function (reply_ret) {
                if (reply_ret.statusCode == 200) {
                    suspend("alert-success", "回复成功: " + reply_ret.message);
                    sleep(500).then(() => {
                        window.location.href = "{{url_for('admin.feedback_show')}}";
                    });
                } else {
                    suspend("alert-danger", "回复失败: " + reply_ret.message);
                }
            },
        });
    }

    $(document).ready(function () {
        let url = "/api/admin_get_report";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;
        $.ajax({
            url: url,
            type: "get",
            data: { feedback_id: feedback_id },
            success: function (ret) {
                kind2str = { 0: "举报用户", 1: "举报物品", 2: "反馈网站bug", 3: "个人提问", 4: "交易维权", 5: "其他" };
                state2str = { 0: "未读 | 未回复", 1: "已读 | 未回复", "-1": "已读 | 已回复" };
                $(feedback_user_id).append(ret.data.user_id);
                $(feedback_type).append(kind2str[ret.data.kind]);
                $(feedback_time).append(ret.data.publish_time);
                $(feedback_content).append(ret.data.feedback_content);
                $(feedback_status).append(state2str[ret.data.state]);

                if (ret.data.state == -1) {
                    $(feedback_reply_old).append(ret.data.reply_content);
                    $(feedback_reply_new).append("更新回复")
                }
                else {
                    $(feedback_reply_old).append("*该反馈未被任何管理员回复过*");
                    $(feedback_reply_new).append("输入回复");
                }
            },
        });
    });
</script>

{% endblock %}

admin/templates/feedback_show.html
{% extends "base.html" %} {% block title %}
<title>反馈清单</title>
{% endblock %} {% block css %} {{ super() }} {% endblock %} {% block header %} {{ super() }} {% endblock %} {% block main %}
<main>
    <section class="shop--area shop-right-sidebar pt-90 pb-90">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-xl-3 col-lg-3 col-md-3 col-sm-12">{% include "cont_side.html" %}</div>
                <div class="col-xl-9 col-lg-9 col-md-9 col-sm-12">
                    <div class="cart-wrapper">
                        <div class="table-responsive">
                            <table class="table mb-0">
                                <thead>
                                    <tr>
                                        <th class="product-name">未阅 | 未回复</th>
                                        <th class="product-name"></th>
                                        <th class="product-name"></th>
                                        <th class="product-name"></th>
                                    </tr>
                                </thead>
                                <tbody id="unread"></tbody>

                                <thead>
                                    <tr>
                                        <th class="product-name">已阅 | 未回复</th>
                                        <th class="product-name"></th>
                                        <th class="product-name"></th>
                                        <th class="product-name"></th>
                                    </tr>
                                </thead>
                                <tbody id="read"></tbody>

                                <thead>
                                    <tr>
                                        <th class="product-name">已阅 | 已回复</th>
                                        <th class="product-name"></th>
                                        <th class="product-name"></th>
                                        <th class="product-name"></th>
                                    </tr>
                                </thead>
                                <tbody id="replied"></tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</main>
{% endblock %} {% block footer %} {{ super() }} {% endblock %} {% block js %} {{ super() }}

<script type="text/javascript" charset="utf-8">
    var debug = 0;
    //var FeedbackstateTostr = { 0: "unread", 1: "read", "-1": "replied" };
    $(document).ready(function () {
        let url = "/api/get_reports";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;
        $.ajax({
            // json形式
            url: url,
            type: "get",
            success: function (ret) {
                if (ret.statusCode == 200) {
                    for (var i in ret.data) {
                        let report_list = $(`#${i}`);
                        for (var j = 0; j < ret.data[i].length; j++) {
                            feedback_id = ret.data[i][j];
                            report_list.append(`<tr id="${feedback_id}"></tr>`);
                            report = $(`#${feedback_id}`);
                            $.ajax({
                                // json形式
                                url: "/api/admin_get_report",
                                type: "get",
                                data: { feedback_id: feedback_id },
                                async: false,
                                success: function (ret) {
                                    // console.log(ret);
                                    report.append(`<td class="product-name"><p>${ret.data.publish_time}</p></td>`);
                                    report.append(`<td class="product-name"><h4>${ret.data.user_id}</h4></td>`);
                                    report.append(`<td class="product-name"><p>${ret.data.feedback_content}</p></td>`);
                                },
                            });
                            report.append(`<td class="product-name"><h4><a href=/admin/feedback/${feedback_id}/>反馈详情</a></h4></td>`);
                        }
                    }
                }
            },
        });
    });
</script>

{% endblock %}

admin/templates/order_check.html
{% extends "base.html" %} {% block title %}
<title>反馈清单</title>
{% endblock %} {% block css %} {{ super() }} {% endblock %} {% block header %} {{ super() }} {% endblock %} {% block main %}
<main>
    <section class="shop--area shop-right-sidebar pt-90 pb-90">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-xl-3 col-lg-3 col-md-3 col-sm-12">{% include "cont_side.html" %}</div>
                <div class="col-xl-9 col-lg-9 col-md-9 col-sm-12">
                    <div class="cart-wrapper">
                        <div class="table-responsive">
                            <table class="table mb-0">
                                <thead>
                                    <tr>
                                        <th class="product-thumbnail"></th>
                                        <th class="product-name">待确认订单</th>
                                        <th class="product-name"></th>
                                        <th class="product-delete"></th>
                                    </tr>
                                </thead>
                                <tbody id="unconfirmed"></tbody>

                                <thead>
                                    <tr>
                                        <th class="product-thumbnail"></th>
                                        <th class="product-name">待完成订单</th>
                                        <th class="product-name"></th>
                                        <th class="product-delete"></th>
                                    </tr>
                                </thead>
                                <tbody id="confirmed"></tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</main>
{% endblock %} {% block footer %} {{ super() }} {% endblock %} {% block js %} {{ super() }}

<script type="text/javascript" charset="utf-8">
    var debug = 0;
    var current_user_id = "{{ current_user.id|safe }}";
    $(document).ready(function () {
        let url = "/api/get_all_order";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;
        $.ajax({
            url: url,
            type: "GET",
            async: false, // 当需要将值传给函数外部时需要强制同步
            success: function (ret) {
                // console.log(ret);
                if (ret.statusCode != 200) {
                    suspend("alert-danger", "获取订单失败: " + ret.message);
                    sleep(500).then(() => {
                        window.location.href = "{{url_for('index')}}";
                    });
                } else {
                    let mytbody;

                    for (let i = 0; i < ret.data.length; i++) {
                        if (ret.data[i].state == 0) mytbody = $("#unconfirmed");
                        else if (ret.data[i].state == 1) mytbody = $("#confirmed");
                        else continue;
                        let order_id = ret.data[i].order_id;
                        mytbody.append(`<tr id="my_order${order_id}"></tr>`);
                        let p_tr = $(`#my_order${order_id}`);

                        let item_id = ret.data[i].item_id_list[0]; //目前还只有一个商品信息
                        p_tr.append(`<td class="product-thumbnail" id="order_item_pic${order_id}"></td>`);
                        p_tr.append(`<td class="product-name" id="order_item_data${order_id}"></td>`);
                        p_tr.append(`<td class="product-name"><h4><a href="/order/${order_id}">订单详情</a></h4></td>`);

                        p_tr.append(`<div id="state_message${order_id}"></div>`);
                        p_tr.append(`<td class="product-delete"> <button class="btn" id="cancel${order_id}" onclick="change_state('${order_id}',-1)">取消订单</button></td>`);

                        let pic_url = "/api/get_item_head_pic";
                        if (debug) pic_url = `http://127.0.0.1:4523/mock/927026${pic_url}`;
                        $.ajax({
                            url: pic_url,
                            type: "GET",
                            data: { item_id: item_id },
                            async: false, // 当需要将值传给函数外部时需要强制同步
                            success: function (pic_ret) {
                                if (pic_ret.statusCode == 200) {
                                    $(`#order_item_pic${order_id}`).append(`<img src=${pic_ret.data.url}>`);
                                }
                            },
                        });
                        let item_url = "/api/get_item_info";
                        if (debug) item_url = `http://127.0.0.1:4523/mock/927026${item_url}`;
                        $.ajax({
                            url: item_url,
                            type: "Get",
                            data: { item_id: item_id },
                            async: false, // 当需要将值传给函数外部时需要强制同步
                            success: function (item_ret) {
                                if (item_ret.statusCode == 200) {
                                    let desc = $(`#order_item_data${order_id}`);
                                    desc.append(`<h4><a href = /item/content/${item_id} >${item_ret.data.name}</a></h4><br/>`);

                                    //desc.append(`<p>${item_ret.data.description}</p>`);

                                    desc.append(`<h4><a href="/user/${item_ret.data.user_id}/user_info">${item_ret.data.user_id}</a></h4>`);
                                    //订单状态逻辑
                                    //let state_message;
                                    //if (ret.data[i].state == 0) {
                                    //    state_message = "等待商家确认";
                                    //} else if (ret.data[i].state == 1) {
                                    //    state_message = "等待收货方完成";
                                    //} else if (ret.data[i].state == -1) {
                                    //    state_message = "已被取消";
                                    //} else if (ret.data[i].state == 2) {
                                    //    state_message = "已完成";
                                    //}
                                    //$(`#state_message${order_id}`).append(`<span><p>订单状态:${state_message}</p></span>`);
                                }
                            },
                        });
                    }
                }
            },
        });
    });
    function change_state(order_id, state) {
        //修改订单状态
        $.ajax({
            url: "/api/change_order_state",
            type: "put",
            data: JSON.stringify({ order_id: order_id, state: state }),
            contentType: "application/json;charset=utf-8",
            processData: false,
            success: function (ret) {
                if (ret.statusCode == 200) {
                    suspend("alert-success", "修改订单状态成功: " + ret.message);
                    sleep(500).then(() => {
                        window.location.reload();
                    });
                } else {
                    suspend("alert-danger", "修改订单状态失败: " + ret.message);
                }
            },
        });
    }
</script>

{% endblock %}

admin/templates/user_check.html
{% extends "base.html" %} {% block title %}
<title>用户管理</title>
{% endblock %} {% block css %} {{ super() }} {% endblock %} {% block header %} {{ super() }} {% endblock %} {% block main %}
<main>
    <section class="shop--area shop-right-sidebar pt-90 pb-90">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-xl-3 col-lg-3 col-md-3 col-sm-12">{% include "cont_side.html" %}</div>
                <div class="col-xl-9 col-lg-9 col-md-9 col-sm-12">

                    <div class="cart-wrapper">
                        <div class="table-responsive">
                            <table class="table mb-0">
                                <thead>
                                    <tr>
                                        <th class="product-thumbnail"></th>
                                        <th class="product-name">用户信息</th> 
                                        <th class="product-name" style="text-align:center">校区</span></th>
                                        <th class="product-name" style="text-align:center">信誉分</th>
                                        <th class="product-name"></th>
                                    </tr>
                                </thead>
                                <tbody id="user_manage"></tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</main>
{% endblock %} {% block footer %} {{ super() }} {% endblock %} {% block js %} {{ super() }}

<script type="text/javascript" charset="utf-8">
    var debug = 0;

    $(document).ready(function () {
        let url = "/api/get_all_user";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;
        $.ajax({
            // json形式
            url: url,
            type: "get",
            success: function (ret) {
                // console.log(ret);
                if (ret.statusCode == 200) {
                    let user_list = $("#user_manage");
                    //user_list.append(`<thead><th>用户名</th><th>详情链接</th></thead>`);
                    for (var i in ret.data) {
                        // console.log(ret.data[i]);
                        user_info = ret.data[i];
                        user_list.append(`<tr id="${user_info.id}"></tr>`);
                        user = $(`#${user_info.id}`);
                        user.append(`<td class="product-thumbnail"><img src="/user/static/resource/user-pic/${user_info.id}/avatar_128.WEBP" alt="" /></td>`)
                        user.append(`<td class="product-name"><h4>${user_info.id}</h4></br>
                            <h4>${user_info.username}</h4></td>`);
                        user.append(`<td class="product-name"><h4>${user_info.campus_branch}</h4></td>`);
                        user.append(`<td class="product-name"><h4>${user_info.score}</h4></td>`);
                        user.append(`<td class="product-name"><h4><a href="/user/${user_info.id}/user_info">用户详情</a></h4></td>`);
                    }
                }
            },
        });
    });
</script>

{% endblock %}